## org.apache.lucene.search
Class MultiSearcher

    java.lang.Object
      org.apache.lucene.search.Searcher
          org.apache.lucene.search.MultiSearcher

All Implemented Interfaces:
  Searchable

Direct Known Subclasses:
  ParallelMultiSearcher

    public class MultiSearcher

extends Searcher

Implements search over a set of `Searchables`.

Applications usually need only call the inherited `Searcher.search(Query)` or `Searcher.search(Query,Filter)` methods.

Constructor Summary
`MultiSearcher(Searchable[] searchables)` Creates a searcher which searches searchers.

Method Summary
`void` `close()` Frees resources associated with this Searcher.
`protected Weight` `createWeight(Query original)` Create weight in multiple index scenario.
`Document` `doc(int n)` Returns the stored fields of document `i`.
`Document` `doc(int n, FieldSelector fieldSelector)` Get the `Document` at the `n`th position.
`int` `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
`Explanation` `explain(Weight weight, int doc)` Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.
`Searchable[]` `getSearchables()` Return the array of `Searchable`s this searches.
`protected int[]` `getStarts()`
`int` `maxDoc()` Expert: Returns one greater than the largest possible document number.
`Query` `rewrite(Query original)` Expert: called to re-write queries into primitive queries.
`void` `search(Weight weight, Filter filter, Collector collector)` Lower-level search API.
`TopDocs` `search(Weight weight, Filter filter, int nDocs)` Expert: Low-level search implementation.
`TopFieldDocs` `search(Weight weight, Filter filter, int n, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.
`int` `subDoc(int n)` Returns the document number of document `n` within its sub-index.
`int` `subSearcher(int n)` Returns index of the searcher for document `n` in the array used to construct this searcher.

Methods inherited from class org.apache.lucene.search.Searcher
`docFreqs, explain, getSimilarity, search, search, search, search, search, search, search, search, search, search, search, search, setSimilarity`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MultiSearcher

    public MultiSearcher(Searchable[] searchables)
                  throws java.io.IOException

  Creates a searcher which searches searchers.

  Throws:
    `java.io.IOException`

Method Detail

### getSearchables

    public Searchable[] getSearchables()

  Return the array of `Searchable`s this searches.

### getStarts

    protected int[] getStarts()

### close

    public void close()
               throws java.io.IOException

  Description copied from interface: `Searchable`
  Frees resources associated with this Searcher. Be careful not to call this method while you are still using objects like `Hits`.

  Specified by:
    `close` in interface `Searchable`
  Specified by:
    `close` in class `Searcher`
  Throws:
    `java.io.IOException`

### docFreq

    public int docFreq(Term term)
                throws java.io.IOException

  Description copied from interface: `Searchable`
  Expert: Returns the number of documents containing `term`.

  Specified by:
    `docFreq` in interface `Searchable`
  Specified by:
    `docFreq` in class `Searcher`
  Throws:
    `java.io.IOException`
  See Also:
    `IndexReader.docFreq(Term)`

### doc

    public Document doc(int n)
                 throws CorruptIndexException,
                        java.io.IOException

  Description copied from interface: `Searchable`
  Returns the stored fields of document `i`.

  Specified by:
    `doc` in interface `Searchable`
  Specified by:
    `doc` in class `Searcher`
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int)`

### doc

    public Document doc(int n,
                        FieldSelector fieldSelector)
                 throws CorruptIndexException,
                        java.io.IOException

  Description copied from interface: `Searchable`
  Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If the underlying Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  Parameters:
    `n` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int, FieldSelector)`, `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### subSearcher

    public int subSearcher(int n)

  Returns index of the searcher for document `n` in the array used to construct this searcher.

### subDoc

    public int subDoc(int n)

  Returns the document number of document `n` within its sub-index.

### maxDoc

    public int maxDoc()
               throws java.io.IOException

  Description copied from interface: `Searchable`
  Expert: Returns one greater than the largest possible document number.

  Specified by:
    `maxDoc` in interface `Searchable`
  Specified by:
    `maxDoc` in class `Searcher`
  Throws:
    `java.io.IOException`
  See Also:
    `IndexReader.maxDoc()`

### search

    public TopDocs search(Weight weight,
                          Filter filter,
                          int nDocs)
                   throws java.io.IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

  Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

  Specified by:
    `search` in interface `Searchable`
  Specified by:
    `search` in class `Searcher`
  Throws:
    `java.io.IOException`

### search

    public TopFieldDocs search(Weight weight,
                               Filter filter,
                               int n,
                               Sort sort)
                        throws java.io.IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `Searcher.search(Query,Filter,int,Sort)` instead.

  Specified by:
    `search` in interface `Searchable`
  Specified by:
    `search` in class `Searcher`
  Throws:
    `java.io.IOException`

### search

    public void search(Weight weight,
                       Filter filter,
                       Collector collector)
                throws java.io.IOException

  Description copied from interface: `Searchable`
  Lower-level search API.

  `Collector.collect(int)` is called for every document.
  Collector-based access to remote indexes is discouraged.

  Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

  Specified by:
    `search` in interface `Searchable`
  Specified by:
    `search` in class `Searcher`
  Parameters:
    `weight` - to match documents
    `filter` - if non-null, used to permit documents to be collected.
    `collector` - to receive hits
  Throws:
    `java.io.IOException`

### rewrite

    public Query rewrite(Query original)
                  throws java.io.IOException

  Description copied from interface: `Searchable`
  Expert: called to re-write queries into primitive queries.

  Specified by:
    `rewrite` in interface `Searchable`
  Specified by:
    `rewrite` in class `Searcher`
  Throws:
    `java.io.IOException`

### explain

    public Explanation explain(Weight weight,
                               int doc)
                        throws java.io.IOException

  Description copied from interface: `Searchable`
  Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Applications should call `Searcher.explain(Query, int)`.

  Specified by:
    `explain` in interface `Searchable`
  Specified by:
    `explain` in class `Searcher`
  Throws:
    `java.io.IOException`

### createWeight

    protected Weight createWeight(Query original)
                           throws java.io.IOException

  Create weight in multiple index scenario. Distributed query processing is done in the following steps: 1. rewrite query 2. extract necessary terms 3. collect dfs for these terms from the Searchables 4. create query weight using aggregate dfs. 5. distribute that weight to Searchables 6. merge results Steps 1-4 are done here, 5+6 in the search() methods

  Overrides:
    `createWeight` in class `Searcher`
  Returns:
    rewritten queries
  Throws:
    `java.io.IOException`

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.